Package jakarta.security.auth.message.config

## Class AuthConfigFactory

- java.lang.Object
- - jakarta.security.auth.message.config.AuthConfigFactory

    public abstract class AuthConfigFactory
    extends java.lang.Object

### Nested Class Summary

Nested Classes
`static interface` `AuthConfigFactory.RegistrationContext`

### Field Summary

Fields
`static java.lang.String` `DEFAULT_FACTORY_SECURITY_PROPERTY`
`static java.lang.String` `GET_FACTORY_PERMISSION_NAME`
`static java.security.SecurityPermission` `getFactorySecurityPermission` Deprecated, for removal: This API element is subject to removal in a future version. Following JEP 411
`static java.lang.String` `PROVIDER_REGISTRATION_PERMISSION_NAME`
`static java.security.SecurityPermission` `providerRegistrationSecurityPermission` Deprecated, for removal: This API element is subject to removal in a future version. Following JEP 411
`static java.lang.String` `SET_FACTORY_PERMISSION_NAME`
`static java.security.SecurityPermission` `setFactorySecurityPermission` Deprecated, for removal: This API element is subject to removal in a future version. Following JEP 411

### Constructor Summary

Constructors
`AuthConfigFactory()`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`abstract java.lang.String[]` `detachListener​(RegistrationListener listener, java.lang.String layer, java.lang.String appContext)`
`abstract AuthConfigProvider` `getConfigProvider​(java.lang.String layer, java.lang.String appContext, RegistrationListener listener)`
`static AuthConfigFactory` `getFactory()`
`abstract AuthConfigFactory.RegistrationContext` `getRegistrationContext​(java.lang.String registrationID)`
`abstract java.lang.String[]` `getRegistrationIDs​(AuthConfigProvider provider)`
`abstract void` `refresh()`
`abstract java.lang.String` `registerConfigProvider​(AuthConfigProvider provider, java.lang.String layer, java.lang.String appContext, java.lang.String description)`
`abstract java.lang.String` `registerConfigProvider​(java.lang.String className, java.util.Map<java.lang.String,​java.lang.String> properties, java.lang.String layer, java.lang.String appContext, java.lang.String description)`
`abstract java.lang.String` `registerServerAuthModule​(ServerAuthModule serverAuthModule, java.lang.Object context)` Convenience method for registering a `ServerAuthModule` that should have the same effect as calling `registerConfigProvider(AuthConfigProvider, String, String, String)` with the implementation providing the appropriate `AuthConfigProvider` generated from the provided context.
`abstract boolean` `removeRegistration​(java.lang.String registrationID)`
`abstract void` `removeServerAuthModule​(java.lang.Object context)` Convenience method for deregistering a `ServerAuthModule` that should have the same effect as calling `removeRegistration(String)`.
`static void` `setFactory​(AuthConfigFactory factory)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_FACTORY_SECURITY_PROPERTY

    public static final java.lang.String DEFAULT_FACTORY_SECURITY_PROPERTY

See Also:
  Constant Field Values

#### GET_FACTORY_PERMISSION_NAME

    public static final java.lang.String GET_FACTORY_PERMISSION_NAME

See Also:
  Constant Field Values

#### SET_FACTORY_PERMISSION_NAME

    public static final java.lang.String SET_FACTORY_PERMISSION_NAME

See Also:
  Constant Field Values

#### PROVIDER_REGISTRATION_PERMISSION_NAME

    public static final java.lang.String PROVIDER_REGISTRATION_PERMISSION_NAME

See Also:
  Constant Field Values

#### getFactorySecurityPermission

    @Deprecated(forRemoval=true)
    public static final java.security.SecurityPermission getFactorySecurityPermission

Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

#### setFactorySecurityPermission

    @Deprecated(forRemoval=true)
    public static final java.security.SecurityPermission setFactorySecurityPermission

Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

#### providerRegistrationSecurityPermission

    @Deprecated(forRemoval=true)
    public static final java.security.SecurityPermission providerRegistrationSecurityPermission

Deprecated, for removal: This API element is subject to removal in a future version.
Following JEP 411

### Constructor Detail

#### AuthConfigFactory

    public AuthConfigFactory()

### Method Detail

#### getFactory

    public static AuthConfigFactory getFactory()

#### setFactory

    public static void setFactory​(AuthConfigFactory factory)

#### getConfigProvider

    public abstract AuthConfigProvider getConfigProvider​(java.lang.String layer,
                                                         java.lang.String appContext,
                                                         RegistrationListener listener)

#### registerConfigProvider

    public abstract java.lang.String registerConfigProvider​(java.lang.String className,
                                                            java.util.Map<java.lang.String,​java.lang.String> properties,
                                                            java.lang.String layer,
                                                            java.lang.String appContext,
                                                            java.lang.String description)

#### registerConfigProvider

    public abstract java.lang.String registerConfigProvider​(AuthConfigProvider provider,
                                                            java.lang.String layer,
                                                            java.lang.String appContext,
                                                            java.lang.String description)

#### removeRegistration

    public abstract boolean removeRegistration​(java.lang.String registrationID)

#### detachListener

    public abstract java.lang.String[] detachListener​(RegistrationListener listener,
                                                      java.lang.String layer,
                                                      java.lang.String appContext)

#### getRegistrationIDs

    public abstract java.lang.String[] getRegistrationIDs​(AuthConfigProvider provider)

#### getRegistrationContext

    public abstract AuthConfigFactory.RegistrationContext getRegistrationContext​(java.lang.String registrationID)

#### refresh

    public abstract void refresh()

#### registerServerAuthModule

    public abstract java.lang.String registerServerAuthModule​(ServerAuthModule serverAuthModule,
                                                              java.lang.Object context)

Convenience method for registering a `ServerAuthModule` that should have the same effect as calling `registerConfigProvider(AuthConfigProvider, String, String, String)` with the implementation providing the appropriate `AuthConfigProvider` generated from the provided context.

Parameters:
  `serverAuthModule` - The `ServerAuthModule` to register
  `context` - The associated application context
Returns:
  A string identifier for the created registration
Since:
  Authentication 3.0

#### removeServerAuthModule

    public abstract void removeServerAuthModule​(java.lang.Object context)

Convenience method for deregistering a `ServerAuthModule` that should have the same effect as calling `removeRegistration(String)`.

Parameters:
  `context` - The associated application context
Since:
  Authentication 3.0